#-----------------------------------------------------------------------------
#
#   Supersymmetry - Game
#
#-----------------------------------------------------------------------------

from humerus.hgame import HGame
from world import World
from options import options
import detection

#-------------------------------------------------------------------------------

class Game(HGame):

	app_magic = "SSym"
	save_file_suffix = ".ssygam"
	detector_image = None
	detector_point = None
	detector_time = 0.0
	detector_frame_time = 0.2 # seconds
	
	frame_time = 1.0 / options.frame_rate_option
	
	@property
	def world(self):
		return self.state

	def new_state(self):
		return World()
	
	def begin_frame(self):
		dt = self.frame_time
		self.world.timestep(dt)
		self.detector_timestep(dt)
	
	def game_is_completed(self):
		return self.world.game_over
	
	def changed(self):
		self.unsaved_progress = True
	
	def detector_timestep(self, dt):
		world = self.world
		if world and world.running:
			self.detector_time += dt
			if self.detector_time >= self.detector_frame_time:
				self.detector_time = 0.0
				image = self.detector_image
				if image:
					self.detector_point = detection.gen_image(self.detector_image)
					#print "game: detector_point =", self.detector_point ###

#-------------------------------------------------------------------------------

game = Game()
import world
world.game = game
